﻿Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        GetSerialPortNames()

    End Sub

    ' This example loops over all the strings that the My.Computer.Ports.SerialPortNames property returns. 
    ' These strings are the names of the available serial ports on the computer.
    Sub GetSerialPortNames()
        ' Show all available COM ports.
        For Each sp As String In My.Computer.Ports.SerialPortNames
            ComboBox1.Items.Add(sp)
        Next
        If ComboBox1.Items.Count <> 0 Then
            ComboBox1.SelectedIndex = 0
        End If
        ComboBox2.SelectedIndex = 0

    End Sub

    'Dec to Hex  function
    Function DectoHex() As String

        Dim briStr As String
        Dim briNum As Integer

        briNum = TrackBar1.Value
 
        briStr = Hex(briNum)
        If Len(briStr) < 2 Then briStr = "0" + briStr
        DectoHex = briStr

    End Function

    ' Connect SerialPort
    Sub SerialPortConnect()

        SerialPort1.Close()
        SerialPort1.PortName = ComboBox1.Text
        SerialPort1.BaudRate = ComboBox2.Text
        SerialPort1.DataBits = 8
        SerialPort1.Parity = 0
        SerialPort1.StopBits = 1
        Try
            SerialPort1.Open()
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try

    End Sub

    ' Send command function
    Sub SendSerialData(ByVal data As String)

        Dim briComm(2) As Byte

        If SerialPort1.IsOpen = False Then
            SerialPortConnect()
        End If
        briComm(0) = &H81  ' Function Command
        briComm(1) = Asc(Mid(DectoHex, 1, 1)) 'HEX value
        briComm(2) = Asc(Mid(DectoHex, 2, 1)) 'HEX value
        If SerialPort1.IsOpen Then
            SerialPort1.Write(briComm, 0, 3)
        Else
            MessageBox.Show("Serial Port Closed")
        End If

    End Sub

    Private Sub TrackBar1_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles TrackBar1.KeyUp

        'When Key Up then send command to a serial port.
        SendSerialData(Label4.Text)

    End Sub

    Private Sub TrackBar1_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles TrackBar1.MouseUp

        'When Mouse Up then send command to a serial port.
        SendSerialData(Label4.Text)

    End Sub

    Private Sub TrackBar1_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar1.Scroll

        Dim valInt As Integer

        valInt = (TrackBar1.Value / 255) * 100
        Label4.Text = Str(valInt)

    End Sub

    Private Sub Form1_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed

        ' Closed  Serial Port 
        If SerialPort1.IsOpen Then
            SerialPort1.Close()
        End If

    End Sub

End Class
